<template>
  <v-dialog
    v-if="size === 'compact'"
    v-model="dialog"
    :scrim="false"
    :absolute="true"
    class="top-10"
    :close-on-content-click="false"
    :contained="true"
  >
    <template #activator="{ props }">
      <svn-pro-button
        v-bind="props"
        variant="text"
        :text="currentSizeLabel"
      />
    </template>

    <template #default>
      <div class="flex flex-col gap-2 py-2 rounded-[4px] w-[200px] max-h-[496px] h-full cardShadow">
        <v-list
          color="primary"
          density="compact"
          class="!py-0"
        >
          <v-list-item
            v-for="size in FONT_SIZES"
            :key="`${size?.label}_${size?.value}`"
            :value="`${size?.label}_${size?.value}`"
            :active="size?.label === currentSizeLabel"
            class="w-full"
            @click="changeSize(size.value)"
          >
            <svn-pro-text bodyLarge regular>
              {{ size.label }}
            </svn-pro-text>
          </v-list-item>
        </v-list>
      </div>
    </template>
  </v-dialog>

  <Popover v-else class="relative">
    <PopoverButton>
      <svn-pro-button
        variant="text"
        :text="currentSizeLabel"
      />
    </PopoverButton>

    <PopoverPanel class="absolute z-10">
      <div class="flex flex-col gap-2 py-2 rounded-[4px] w-[200px] max-h-[496px] min-w-[112px] h-full cardShadow overflow-y-auto">
        <v-list
          color="primary"
          density="compact"
          class="!py-0"
        >
          <v-list-item
            v-for="size in FONT_SIZES"
            :key="`${size?.label}_${size?.value}`"
            :value="`${size?.label}_${size?.value}`"
            :active="size?.label === currentSizeLabel"
            class="w-full"
            @click="changeSize(size.value)"
          >
            <svn-pro-text bodyLarge regular>
              {{ size.label }}
            </svn-pro-text>
          </v-list-item>
        </v-list>
      </div>
    </PopoverPanel>
  </Popover>
</template>

<script setup>
import { watch, ref, onMounted } from 'vue';
import SvnProButton from '../../button/SvnProButton.vue';
import SvnProText from '../../styles/SvnProText.vue';
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue'

const props = defineProps({
  value: { type: String, default: '' },
  size: { type: String, default: null },
})

onMounted(() => {
  currentValue.value = FONT_SIZES.find(size => size.value === props.value)
  currentSizeLabel.value = currentValue?.value?.label.split(' ')[0] || 'Normal'
})

const emit = defineEmits(['change-size']);

const dialog = ref(false);
const currentValue = ref({});
const currentSizeLabel = ref(null);

const FONT_SIZES = [
  { label: 'Tiny', value: '10px' },
  { label: 'Smaller', value: '12px' },
  { label: 'Small', value: '14px' },
  { label: 'Normal', value: '16px' },
  { label: 'Large', value: '18px' },
  { label: 'Extra Large', value: '24px' },
  { label: 'Mega Large', value: '30px' },
]

const changeSize = (size) => {
  emit('change-size', size)
}

watch(props, (newValue, oldValue) => {
  if (newValue.value) {
    currentValue.value = FONT_SIZES.find(size => size.value === newValue.value)
    currentSizeLabel.value = currentValue?.value?.label.split(' ')[0] || 'Normal'
  }
})
</script>

<style scoped>
.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>